import e from"query-string";import{schema as t,normalize as r}from"normalizr";import{createSelector as n}from"reselect";import{combineReducers as s}from"redux";import i,{useState as o,useRef as a,useEffect as u}from"react";import l from"hoist-non-react-statics";import d from"validate.js";const c={UPSERT:"snowbox/UPSERT",REMOVE:"snowbox/REMOVE",FIND:"snowbox/FIND",FETCH:"snowbox/FETCH",CLEAR:"snowbox/CLEAR",NO_FETCH:"snowbox/NO_FETCH"},f="pending",y="succeeded",h="failed",p={JSON:"snowbox/JSON",FORM_DATA:"snowbox/FORM_DATA"};var E=new class{setBaseUrl(e){if("string"!=typeof e)throw new Error("[Snowbox] Api base url must be string");this.baseUrl=e}setTokenHeaderName(e){if("string"!=typeof e)throw new Error("[Snowbox] Token Header Name must be string");this.tokenHeader=e}setHeaderRequest(e,t){if(this.requestHeaders||(this.requestHeaders={}),"string"!=typeof e)throw new Error("[Snowbox] Request header name must be a string");if("string"!=typeof t)throw new Error("[Snowbox] Request header value must be a string");this.requestHeaders[e]=t}setTokenGetter(e){if("function"!=typeof e)throw new Error("[Snowbox] Token Getter must be function");this.tokenGetter=e}async setAuthToken(e){if(!this.tokenGetter||!this.tokenHeader)return;const t=await this.tokenGetter();t&&e.setRequestHeader(this.tokenHeader,t)}get(e,t){return this.call("GET",e,t)}post(e,t={},r,n){return this.call("POST",e,r,t,n)}put(e,t={},r,n){return this.call("PUT",e,r,t,n)}patch(e,t={},r,n){return this.call("PATCH",e,r,t,n)}remove(e){return this.call("DELETE",e)}async call(t,r,n,s,i=p.JSON){if(!this.baseUrl)throw new Error("[Snowbox] Base API url must be defined");return new Promise((async(o,a)=>{const u=new XMLHttpRequest,l=r.indexOf("?")>-1?"&":"?",d="object"==typeof n?l+e.stringify(n):"";let c;switch(u.open(t,`${this.baseUrl}${r}${d}`,!0),u.onload=()=>{if(4!=u.readyState)return!1;let e;try{e=JSON.parse(u.responseText)}catch(t){e=u.responseText}u.status>=200&&u.status<300?o(e.data?e.data:e):a({status:u.status,message:e.message||e})},i){case p.JSON:u.setRequestHeader("Content-type","application/json; charset=utf-8"),s&&(c=JSON.stringify(s));break;case p.FORM_DATA:u.setRequestHeader("Content-type","multipart/form-data"),"object"==typeof s&&(c=new FormData,Object.keys(s).forEach((e=>c.append(e,s[e]))));break;default:return a(new Error(`[Snowbox] Invalid content type "${i}"`))}this.requestHeaders&&0!==Object.keys(this.requestHeaders).length&&Object.keys(this.requestHeaders).forEach((e=>{u.setRequestHeader(e,this.requestHeaders[e])})),await this.setAuthToken(u),u.send(s?c:void 0)}))}};class m{constructor(e){this.particleDefinition=e}fetch(e){const t=this.getFetchPath(e),r=this.getFetchParams(e);return E.get(t,r)}upsert(e,t){const r=this.getUpsertPath(e),n=this.getUpsertMethod(e);return E[n](r,e,t,this.getUpsertContentType())}remove(e){const t=this.getParticle(e),r="number"==typeof e?e:e.id;return E.remove(`/${t}/${r}`)}getParticle(e){return"function"==typeof this.particleDefinition?this.particleDefinition(e):this.particleDefinition}getFetchPath(e){const t=this.getParticle(e);return e&&"object"!=typeof e?`/${t}/${e}`:`/${t}`}getFetchParams(e){return"object"==typeof e?e:null}getUpsertPath(e){const t=this.getParticle(e);return e.id?`/${t}/${e.id}`:`/${t}`}getUpsertMethod(e){return e.id?"put":"post"}getUpsertContentType(){return p.JSON}}const b=(e,r,n={},s={})=>{const i=new t.Entity(e,n,s);if(r){if("object"!=typeof r&&"Provider"!=r.constructor.name)throw new Error("[Snowbox] Invalid provider");i.provider=r}return"number"==typeof s.staleTimeout&&(i.staleTimeout=s.staleTimeout),!0===s.singleton&&(i.singleton=!0),i},v=e=>`${e}_SUCCESS`,w=e=>`${e}_FAILURE`,g=e=>(t={})=>({type:e,...t}),T=e=>t=>(r,n,s,i)=>({type:v(e),entity:t,data:r,entities:n,result:s,date:i}),k=e=>t=>(r,n,s)=>({type:w(e),entity:t,data:r,error:n,statusCode:s}),F=e=>t=>(r,n={})=>({type:e,entity:t,data:r,options:n,success:T(e)(t),failure:k(e)(t)}),S=F(c.UPSERT),A=F(c.REMOVE),H=F(c.FIND),R=F(c.FETCH),C=g(c.CLEAR),O=g(c.NO_FETCH),x=(e={})=>!e||"object"!=typeof e||Array.isArray(e)?"#":Object.keys(e).sort().reduce(((t,r)=>t+=`${r}[${e[r]}]`),"#"),P=e=>e.snowbox,U=n(P,(e=>e.meta)),D=n(P,(e=>e.entities)),N=n(P,(e=>e.singletons)),_=(e,t=0)=>r=>n=>{if(!n||!t)return n;if(Array.isArray(n))return n.map((n=>_(e,t)(r)(n)));const s={...n};for(const i in e.schema){const o=Array.isArray(e.schema[i])?e.schema[i][0]:e.schema[i];s[i]=_(o,t-1)(r)(Array.isArray(n[i])?n[i].map((e=>r[o.key][e])):r[o.key][n[i]])}return s},$=(e,t=0)=>r=>{if(e.singleton)return n(N,(t=>t[e.key]));const s=_(e,t);return n(D,(t=>t[e.key]?s(t)(t[e.key][r]):null))},q=[],M=(e,t=0)=>r=>{const s=_(e,t);return n(D,U,((t,n)=>{if(!t[e.key])return q;const i=x(r),o=n[e.key]?n[e.key][i]:null;if(!o||!o.result)return s(t)(Object.values(t[e.key]));const a=o.result.map((r=>t[e.key][r]));return s(t)(a)}))},j=[c.FETCH,v(c.FETCH),w(c.FETCH),c.FIND,v(c.FIND),w(c.FIND),c.UPSERT,v(c.UPSERT),w(c.UPSERT),c.REMOVE,v(c.REMOVE),w(c.REMOVE)],I=(e={},t)=>{switch(t.type){case c.FETCH:return{progress:f};case v(c.FETCH):return{progress:y,result:t.result,__updatedAt:t.date};case w(c.FETCH):return{progress:h,error:t.error}}},V=(e={},t)=>{const r=x(t.data);return{...e,[r]:I(e[r],t)}},J=s({entities:(e={},t)=>{var r;if(!j.includes(t.type))return e;if(null!=t&&null!==(r=t.entity)&&void 0!==r&&r.singleton)return e;if(t.type==v(c.REMOVE)){const r={...e,[t.entity.key]:{...e[t.entity.key]}},n="number"==typeof t.data?t.data:t.data[t.entity.idAttribute];return delete r[t.entity.key][n],r}if(!t.entities)return e;const n={...e};for(const e in t.entities){n[e]={...n[e]||{}};for(const r in t.entities[e])n[e][r]={...(n[e]||{})[r]||{},...t.entities[e][r],__updatedAt:t.date}}return n},meta:(e={},t)=>{if(![c.FETCH,v(c.FETCH),w(c.FETCH)].includes(t.type))return e;const r=Array.isArray(t.entity)?t.entity[0]:t.entity;return r.singleton?e:{...e,[r.key]:V(e[r.key],t)}},singletons:(e={},t)=>{var r;if(!j.includes(t.type))return e;if(null==t||null===(r=t.entity)||void 0===r||!r.singleton)return e;const n={...e};return t.type==v(c.REMOVE)?(delete n[t.entity.key],n):(n[t.entity.key]={...t.result,__updatedAt:t.date},n)}}),L=(e,t)=>t.type==c.CLEAR?J(void 0,t):J(e,t),B={[c.UPSERT]:"upsert",[c.REMOVE]:"remove",[c.FIND]:"fetch",[c.FETCH]:"fetch"},G=e=>t=>async n=>{if(![c.UPSERT,c.REMOVE,c.FIND,c.FETCH].includes(n.type))return t(n);const s=B[n.type],i=Array.isArray(n.entity)?n.entity[0]:n.entity;if("fetch"==s&&!((e,t,r)=>{var n,s;if(!t.staleTimeout)return!0;if(null!=r&&null!==(n=r.options)&&void 0!==n&&n.refresh)return!0;let i;if(Array.isArray(r.entity)){var o,a,u;const n=x(r.data);i=null==e||null===(o=e.snowbox)||void 0===o||null===(a=o.meta)||void 0===a||null===(u=a[t.key])||void 0===u?void 0:u[n]}else if(t.singleton){var l,d;i=null==e||null===(l=e.snowbox)||void 0===l||null===(d=l.singletons)||void 0===d?void 0:d[t.key]}else{var c,f,y;const n=r.data[t.idAttribute];i=null==e||null===(c=e.snowbox)||void 0===c||null===(f=c.entities)||void 0===f||null===(y=f[t.key])||void 0===y?void 0:y[n]}return null===(s=i)||void 0===s||!s.__updatedAt||Date.now()-i.__updatedAt>t.staleTimeout})(e.getState(),i,n))return t(O());t(n);try{const e=await i.provider[s](n.data);if("remove"==s)return t(n.success(n.data));if(i.singleton)return t(n.success(n.data,void 0,e,Date.now()));const{entities:o,result:a}=r(e,n.entity);return t(n.success(n.data,o,a,Date.now()))}catch(e){return t(n.failure(n.data,e,e.status))}},z=e=>(t={},r)=>{const n={valid:!0,touched:!1,error:null,submitted:!1,fields:{}},s=r||t;return e.forEach((e=>{n.fields[e]={valid:!0,touched:!1,error:null,value:void 0===s[e]?null:s[e]}})),n},X=e=>t=>e.reduce(((e,r)=>({...e,[r]:t.fields[r].value})),{}),K=(e,t)=>r=>{const n=d(X(e)(r),t);let s=!0;return e.forEach((e=>{const t=n&&n[e]?n[e][0]:null;s=s&&!t,r={...r,valid:s,fields:{...r.fields,[e]:{...r.fields[e],error:t,valid:!t}}}})),r},Q=(e,t)=>(r,n,s)=>{if(!e.includes(n))throw new Error(`[Snowbox Form] Unknown field: ${n}`);let i={...r,fields:{...r.fields,[n]:{...r.fields[n],value:s}}};return K(e,t)(i)},W=e=>(t,r)=>{if(!e.includes(r))throw new Error(`[Snowbox Form] Unknown field: ${r}`);return{...t,touched:!0,fields:{...t.fields,[r]:{...t.fields[r],touched:!0}}}},Y=e=>(t,r)=>{const n=e.reduce(((e,t)=>({...e,valid:e.valid&&!r[t],submitted:!1,fields:{...e.fields,[t]:{...e.fields[t],error:r[t]||null,valid:!r[t]}}})),t);return r._error&&(n.error=r._error,n.valid=!1),n},Z=e=>t=>{const r=e.reduce(((e,t)=>({...e,fields:{...e.fields,[t]:{...e.fields[t],touched:!0}}})),t);return r.valid&&(r.submitted=!0),r},ee=({fields:e,submitForm:t,initialValues:r={}})=>n=>{const s=((e,t)=>({buildInitialState:z(e),getData:X(e),validate:K(e,t),handleChange:Q(e,t),handleBlur:W(e),handleServerErrors:Y(e),handleSubmit:Z(e)}))(Object.keys(e),e);return l(((e={})=>{const[l,d]=o(s.buildInitialState(r,e.initialValues)),c=a(!0);u((()=>{c.current&&(c.current=!1,d((e=>s.validate(e))))}));const f=(e,t)=>{d((r=>s.handleChange(r,e,t)))},y=e=>{d((t=>s.handleBlur(t,e)))},h=e=>{d((t=>s.handleServerErrors(t,e)))},p=Object.keys(l.fields).reduce(((e,t)=>({...e,[t]:{...l.fields[t],name:t,onBlur:()=>y(t),onChange:e=>f(t,e)}})),{});return i.createElement(n,{...e,fields:p,form:{valid:l.valid,touched:l.touched,error:l.error},onFieldChange:f,onFieldBlur:y,onSubmit:async()=>{const n=s.handleSubmit(l);if(d(n),!n.valid)return;!1!==await t(e,s.getData(n),h)&&(d(s.buildInitialState(r,e.initialValues)),c.current=!0)}})}),n)};export{m as Provider,c as actions,E as api,C as clearAll,p as contentTypes,b as entity,R as fetch,H as find,A as remove,M as selectMany,$ as selectOne,G as snowboxMiddleware,L as snowboxReducer,S as upsert,ee as withForm};
