"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var e=require("query-string"),t=require("normalizr"),r=require("reselect"),n=require("redux"),s=require("react"),i=require("hoist-non-react-statics"),o=require("validate.js");function a(e){return e&&"object"==typeof e&&"default"in e?e:{default:e}}var u=a(e),l=a(s),d=a(i),c=a(o);const f={UPSERT:"snowbox/UPSERT",REMOVE:"snowbox/REMOVE",FIND:"snowbox/FIND",FETCH:"snowbox/FETCH",CLEAR:"snowbox/CLEAR",NO_FETCH:"snowbox/NO_FETCH"},y="pending",h="succeeded",p="failed",E={JSON:"snowbox/JSON",FORM_DATA:"snowbox/FORM_DATA"};var b=new class{setBaseUrl(e){if("string"!=typeof e)throw new Error("[Snowbox] Api base url must be string");this.baseUrl=e}setTokenHeaderName(e){if("string"!=typeof e)throw new Error("[Snowbox] Token Header Name must be string");this.tokenHeader=e}setHeaderRequest(e,t){if(this.requestHeaders||(this.requestHeaders={}),"string"!=typeof e)throw new Error("[Snowbox] Request header name must be a string");if("string"!=typeof t)throw new Error("[Snowbox] Request header value must be a string");this.requestHeaders[e]=t}setTokenGetter(e){if("function"!=typeof e)throw new Error("[Snowbox] Token Getter must be function");this.tokenGetter=e}async setAuthToken(e){if(!this.tokenGetter||!this.tokenHeader)return;const t=await this.tokenGetter();t&&e.setRequestHeader(this.tokenHeader,t)}get(e,t){return this.call("GET",e,t)}post(e,t={},r,n){return this.call("POST",e,r,t,n)}put(e,t={},r,n){return this.call("PUT",e,r,t,n)}patch(e,t={},r,n){return this.call("PATCH",e,r,t,n)}remove(e){return this.call("DELETE",e)}async call(e,t,r,n,s=E.JSON){if(!this.baseUrl)throw new Error("[Snowbox] Base API url must be defined");return new Promise((async(i,o)=>{const a=new XMLHttpRequest,l=t.indexOf("?")>-1?"&":"?",d="object"==typeof r?l+u.default.stringify(r):"";let c;switch(a.open(e,`${this.baseUrl}${t}${d}`,!0),a.onload=()=>{if(4!=a.readyState)return!1;let e;try{e=JSON.parse(a.responseText)}catch(t){e=a.responseText}a.status>=200&&a.status<300?i(e.data?e.data:e):o({status:a.status,message:e.message||e})},s){case E.JSON:a.setRequestHeader("Content-type","application/json; charset=utf-8"),n&&(c=JSON.stringify(n));break;case E.FORM_DATA:a.setRequestHeader("Content-type","multipart/form-data"),"object"==typeof n&&(c=new FormData,Object.keys(n).forEach((e=>c.append(e,n[e]))));break;default:return o(new Error(`[Snowbox] Invalid content type "${s}"`))}this.requestHeaders&&0!==Object.keys(this.requestHeaders).length&&Object.keys(this.requestHeaders).forEach((e=>{a.setRequestHeader(e,this.requestHeaders[e])})),await this.setAuthToken(a),a.send(n?c:void 0)}))}};const v=e=>`${e}_SUCCESS`,w=e=>`${e}_FAILURE`,m=e=>(t={})=>({type:e,...t}),g=e=>t=>(r,n,s,i)=>({type:v(e),entity:t,data:r,entities:n,result:s,date:i}),T=e=>t=>(r,n,s)=>({type:w(e),entity:t,data:r,error:n,statusCode:s}),S=e=>t=>(r,n={})=>({type:e,entity:t,data:r,options:n,success:g(e)(t),failure:T(e)(t)}),x=S(f.UPSERT),k=S(f.REMOVE),F=S(f.FIND),A=S(f.FETCH),R=m(f.CLEAR),H=m(f.NO_FETCH),O=(e={})=>!e||"object"!=typeof e||Array.isArray(e)?"#":Object.keys(e).sort().reduce(((t,r)=>t+=`${r}[${e[r]}]`),"#"),C=e=>e.snowbox,P=r.createSelector(C,(e=>e.meta)),q=r.createSelector(C,(e=>e.entities)),U=r.createSelector(C,(e=>e.singletons)),D=(e,t=0)=>r=>n=>{if(!n||!t)return n;if(Array.isArray(n))return n.map((n=>D(e,t)(r)(n)));const s={...n};for(const i in e.schema){const o=Array.isArray(e.schema[i])?e.schema[i][0]:e.schema[i];s[i]=D(o,t-1)(r)(Array.isArray(n[i])?n[i].map((e=>r[o.key][e])):r[o.key][n[i]])}return s},_=[],N=[f.FETCH,v(f.FETCH),w(f.FETCH),f.FIND,v(f.FIND),w(f.FIND),f.UPSERT,v(f.UPSERT),w(f.UPSERT),f.REMOVE,v(f.REMOVE),w(f.REMOVE)],M=(e={},t)=>{switch(t.type){case f.FETCH:return{progress:y};case v(f.FETCH):return{progress:h,result:t.result,__updatedAt:t.date};case w(f.FETCH):return{progress:p,error:t.error}}},$=(e={},t)=>{const r=O(t.data);return{...e,[r]:M(e[r],t)}},j=n.combineReducers({entities:(e={},t)=>{var r;if(!N.includes(t.type))return e;if(null!=t&&null!==(r=t.entity)&&void 0!==r&&r.singleton)return e;if(t.type==v(f.REMOVE)){const r={...e,[t.entity.key]:{...e[t.entity.key]}},n="number"==typeof t.data?t.data:t.data[t.entity.idAttribute];return delete r[t.entity.key][n],r}if(!t.entities)return e;const n={...e};for(const e in t.entities){n[e]={...n[e]||{}};for(const r in t.entities[e])n[e][r]={...(n[e]||{})[r]||{},...t.entities[e][r],__updatedAt:t.date}}return n},meta:(e={},t)=>{if(![f.FETCH,v(f.FETCH),w(f.FETCH)].includes(t.type))return e;const r=Array.isArray(t.entity)?t.entity[0]:t.entity;return r.singleton?e:{...e,[r.key]:$(e[r.key],t)}},singletons:(e={},t)=>{var r;if(!N.includes(t.type))return e;if(null==t||null===(r=t.entity)||void 0===r||!r.singleton)return e;const n={...e};return t.type==v(f.REMOVE)?(delete n[t.entity.key],n):(n[t.entity.key]={...t.result,__updatedAt:t.date},n)}}),I={[f.UPSERT]:"upsert",[f.REMOVE]:"remove",[f.FIND]:"fetch",[f.FETCH]:"fetch"},V=e=>(t={},r)=>{const n={valid:!0,touched:!1,error:null,submitted:!1,fields:{}},s=r||t;return e.forEach((e=>{n.fields[e]={valid:!0,touched:!1,error:null,value:void 0===s[e]?null:s[e]}})),n},J=e=>t=>e.reduce(((e,r)=>({...e,[r]:t.fields[r].value})),{}),L=(e,t)=>r=>{const n=c.default(J(e)(r),t);let s=!0;return e.forEach((e=>{const t=n&&n[e]?n[e][0]:null;s=s&&!t,r={...r,valid:s,fields:{...r.fields,[e]:{...r.fields[e],error:t,valid:!t}}}})),r},B=(e,t)=>(r,n,s)=>{if(!e.includes(n))throw new Error(`[Snowbox Form] Unknown field: ${n}`);let i={...r,fields:{...r.fields,[n]:{...r.fields[n],value:s}}};return L(e,t)(i)},G=e=>(t,r)=>{if(!e.includes(r))throw new Error(`[Snowbox Form] Unknown field: ${r}`);return{...t,touched:!0,fields:{...t.fields,[r]:{...t.fields[r],touched:!0}}}},z=e=>(t,r)=>{const n=e.reduce(((e,t)=>({...e,valid:e.valid&&!r[t],submitted:!1,fields:{...e.fields,[t]:{...e.fields[t],error:r[t]||null,valid:!r[t]}}})),t);return r._error&&(n.error=r._error,n.valid=!1),n},X=e=>t=>{const r=e.reduce(((e,t)=>({...e,fields:{...e.fields,[t]:{...e.fields[t],touched:!0}}})),t);return r.valid&&(r.submitted=!0),r};exports.Provider=class{constructor(e){this.particleDefinition=e}fetch(e){const t=this.getFetchPath(e),r=this.getFetchParams(e);return b.get(t,r)}upsert(e,t){const r=this.getUpsertPath(e),n=this.getUpsertMethod(e);return b[n](r,e,t,this.getUpsertContentType())}remove(e){const t=this.getParticle(e),r="number"==typeof e?e:e.id;return b.remove(`/${t}/${r}`)}getParticle(e){return"function"==typeof this.particleDefinition?this.particleDefinition(e):this.particleDefinition}getFetchPath(e){const t=this.getParticle(e);return e&&"object"!=typeof e?`/${t}/${e}`:`/${t}`}getFetchParams(e){return"object"==typeof e?e:null}getUpsertPath(e){const t=this.getParticle(e);return e.id?`/${t}/${e.id}`:`/${t}`}getUpsertMethod(e){return e.id?"put":"post"}getUpsertContentType(){return E.JSON}},exports.actions=f,exports.api=b,exports.clearAll=R,exports.contentTypes=E,exports.entity=(e,r,n={},s={})=>{const i=new t.schema.Entity(e,n,s);if(r){if("object"!=typeof r&&"Provider"!=r.constructor.name)throw new Error("[Snowbox] Invalid provider");i.provider=r}return"number"==typeof s.staleTimeout&&(i.staleTimeout=s.staleTimeout),!0===s.singleton&&(i.singleton=!0),i},exports.fetch=A,exports.find=F,exports.remove=k,exports.selectMany=(e,t=0)=>n=>{const s=D(e,t);return r.createSelector(q,P,((t,r)=>{if(!t[e.key])return _;const i=O(n),o=r[e.key]?r[e.key][i]:null;if(!o||!o.result)return s(t)(Object.values(t[e.key]));const a=o.result.map((r=>t[e.key][r]));return s(t)(a)}))},exports.selectOne=(e,t=0)=>n=>{if(e.singleton)return r.createSelector(U,(t=>t[e.key]));const s=D(e,t);return r.createSelector(q,(t=>t[e.key]?s(t)(t[e.key][n]):null))},exports.snowboxMiddleware=e=>r=>async n=>{if(![f.UPSERT,f.REMOVE,f.FIND,f.FETCH].includes(n.type))return r(n);const s=I[n.type],i=Array.isArray(n.entity)?n.entity[0]:n.entity;if("fetch"==s&&!((e,t,r)=>{var n,s;if(!t.staleTimeout)return!0;if(null!=r&&null!==(n=r.options)&&void 0!==n&&n.refresh)return!0;let i;if(Array.isArray(r.entity)){var o,a,u;const n=O(r.data);i=null==e||null===(o=e.snowbox)||void 0===o||null===(a=o.meta)||void 0===a||null===(u=a[t.key])||void 0===u?void 0:u[n]}else if(t.singleton){var l,d;i=null==e||null===(l=e.snowbox)||void 0===l||null===(d=l.singletons)||void 0===d?void 0:d[t.key]}else{var c,f,y;const n=r.data[t.idAttribute];i=null==e||null===(c=e.snowbox)||void 0===c||null===(f=c.entities)||void 0===f||null===(y=f[t.key])||void 0===y?void 0:y[n]}return null===(s=i)||void 0===s||!s.__updatedAt||Date.now()-i.__updatedAt>t.staleTimeout})(e.getState(),i,n))return r(H());r(n);try{const e=await i.provider[s](n.data);if("remove"==s)return r(n.success(n.data));if(i.singleton)return r(n.success(n.data,void 0,e,Date.now()));const{entities:o,result:a}=t.normalize(e,n.entity);return r(n.success(n.data,o,a,Date.now()))}catch(e){return r(n.failure(n.data,e,e.status))}},exports.snowboxReducer=(e,t)=>t.type==f.CLEAR?j(void 0,t):j(e,t),exports.upsert=x,exports.withForm=({fields:e,submitForm:t,initialValues:r={}})=>n=>{const i=((e,t)=>({buildInitialState:V(e),getData:J(e),validate:L(e,t),handleChange:B(e,t),handleBlur:G(e),handleServerErrors:z(e),handleSubmit:X(e)}))(Object.keys(e),e);return d.default(((e={})=>{const[o,a]=s.useState(i.buildInitialState(r,e.initialValues)),u=s.useRef(!0);s.useEffect((()=>{u.current&&(u.current=!1,a((e=>i.validate(e))))}));const d=(e,t)=>{a((r=>i.handleChange(r,e,t)))},c=e=>{a((t=>i.handleBlur(t,e)))},f=e=>{a((t=>i.handleServerErrors(t,e)))},y=Object.keys(o.fields).reduce(((e,t)=>({...e,[t]:{...o.fields[t],name:t,onBlur:()=>c(t),onChange:e=>d(t,e)}})),{});return l.default.createElement(n,{...e,fields:y,form:{valid:o.valid,touched:o.touched,error:o.error},onFieldChange:d,onFieldBlur:c,onSubmit:async()=>{const n=i.handleSubmit(o);if(a(n),!n.valid)return;!1!==await t(e,i.getData(n),f)&&(a(i.buildInitialState(r,e.initialValues)),u.current=!0)}})}),n)};
